Index: docs/topics/forms/modelforms.txt
===================================================================
--- docs/topics/forms/modelforms.txt	(revision 16341)
+++ docs/topics/forms/modelforms.txt	(working copy)
@@ -83,6 +83,8 @@
 
     ``IPAddressField``               ``IPAddressField``
 
+    ``IPv46AddressField``            ``IPv46AddressField``
+
     ``ManyToManyField``              ``ModelMultipleChoiceField`` (see
                                      below)
 
Index: docs/ref/models/fields.txt
===================================================================
--- docs/ref/models/fields.txt	(revision 16341)
+++ docs/ref/models/fields.txt	(working copy)
@@ -755,6 +755,16 @@
 An IP address, in string format (e.g. "192.0.2.30"). The admin represents this
 as an ``<input type="text">`` (a single-line input).
 
+``IPv46AddressField``
+---------------------
+
+.. class:: IPv46AddressField([**options])
+
+.. versionadded:: 1.4
+
+An IPv4 or IPv6 address, in string format (e.g. "192.0.2.30" or "2a02:42fe::4") 
+The admin represents this as an ``<input type="text">`` (a single-line input).
+
 ``NullBooleanField``
 --------------------
 
Index: docs/ref/forms/fields.txt
===================================================================
--- docs/ref/forms/fields.txt	(revision 16341)
+++ docs/ref/forms/fields.txt	(working copy)
@@ -622,6 +622,47 @@
       expression.
     * Error message keys: ``required``, ``invalid``
 
+``IPv46AddressField``
+~~~~~~~~~~~~~~~~~~~~~
+
+.. class:: IPv46AddressField(**kwargs)
+
+.. versionadded:: 1.4
+
+A field containing either an IPv4 or an IPv6 address.
+
+    * Default widget: ``TextInput``
+    * Empty value: ``''`` (an empty string)
+    * Normalizes to: A Unicode object. By default, IPv6 addresses are
+      normalized as described below.
+    * Validates that the given value is a valid IP address, using regular
+      expressions.
+    * Error message keys: ``required``, ``invalid``
+
+The IPv6 address normalisation follows `RFC4291 section 2.2`_, including using
+the IPv4 format suggested in paragraph 3 of that section. For example,
+``2001:0::0:01`` would be compressed to ``2001::1`` and ``::0a0a:0a0a``
+to ``::10.10.10.10``. This behaviour can be disabled by setting the
+``skip_ipv6_normalisation`` attribute.
+
+.. _RFC4291 section 2.2: http://tools.ietf.org/html/rfc4291#section-2.2
+
+Takes three optional arguments:
+
+.. attribute:: IPv46AddressField.skip_ipv6_normalisation
+
+    Disables the IPv6 address normalisation described above.
+
+.. attribute:: IPv46AddressField.only_ipv4
+
+    Limits valid inputs to only IPv4 addresses
+
+.. attribute:: IPv46AddressField.only_ipv6
+
+    Limits valid inputs to only IPv6 addresses
+
+Setting both ``only_ipv4`` and ``only_ipv6`` is invalid.
+
 ``MultipleChoiceField``
 ~~~~~~~~~~~~~~~~~~~~~~~
 
Index: django/db/models/fields/__init__.py
===================================================================
--- django/db/models/fields/__init__.py	(revision 16341)
+++ django/db/models/fields/__init__.py	(working copy)
@@ -919,7 +919,7 @@
 
 class IPAddressField(Field):
     empty_strings_allowed = False
-    description = _("IP address")
+    description = _("IPv4 address")
     def __init__(self, *args, **kwargs):
         kwargs['max_length'] = 15
         Field.__init__(self, *args, **kwargs)
@@ -932,6 +932,21 @@
         defaults.update(kwargs)
         return super(IPAddressField, self).formfield(**defaults)
 
+class IPv46AddressField(Field):
+    empty_strings_allowed = False
+    description = _("IP address")
+    def __init__(self, *args, **kwargs):
+        kwargs['max_length'] = 39
+        Field.__init__(self, *args, **kwargs)
+
+    def get_internal_type(self):
+        return "IPv46AddressField"
+
+    def formfield(self, **kwargs):
+        defaults = {'form_class': forms.IPv46AddressField}
+        defaults.update(kwargs)
+        return super(IPv46AddressField, self).formfield(**defaults)
+
 class NullBooleanField(Field):
     empty_strings_allowed = False
     default_error_messages = {
Index: django/db/backends/sqlite3/creation.py
===================================================================
--- django/db/backends/sqlite3/creation.py	(revision 16341)
+++ django/db/backends/sqlite3/creation.py	(working copy)
@@ -20,6 +20,7 @@
         'IntegerField':                 'integer',
         'BigIntegerField':              'bigint',
         'IPAddressField':               'char(15)',
+        'IPv46AddressField':            'char(39)',
         'NullBooleanField':             'bool',
         'OneToOneField':                'integer',
         'PositiveIntegerField':         'integer unsigned',
Index: django/db/backends/mysql/creation.py
===================================================================
--- django/db/backends/mysql/creation.py	(revision 16341)
+++ django/db/backends/mysql/creation.py	(working copy)
@@ -19,6 +19,7 @@
         'IntegerField':      'integer',
         'BigIntegerField':   'bigint',
         'IPAddressField':    'char(15)',
+        'IPv46AddressField': 'char(39)',
         'NullBooleanField':  'bool',
         'OneToOneField':     'integer',
         'PositiveIntegerField': 'integer UNSIGNED',
Index: django/db/backends/oracle/creation.py
===================================================================
--- django/db/backends/oracle/creation.py	(revision 16341)
+++ django/db/backends/oracle/creation.py	(working copy)
@@ -27,6 +27,7 @@
         'IntegerField':                 'NUMBER(11)',
         'BigIntegerField':              'NUMBER(19)',
         'IPAddressField':               'VARCHAR2(15)',
+        'IPv46AddressField':            'VARCHAR2(39)',
         'NullBooleanField':             'NUMBER(1) CHECK ((%(qn_column)s IN (0,1)) OR (%(qn_column)s IS NULL))',
         'OneToOneField':                'NUMBER(11)',
         'PositiveIntegerField':         'NUMBER(11) CHECK (%(qn_column)s >= 0)',
Index: django/db/backends/postgresql_psycopg2/introspection.py
===================================================================
--- django/db/backends/postgresql_psycopg2/introspection.py	(revision 16341)
+++ django/db/backends/postgresql_psycopg2/introspection.py	(working copy)
@@ -12,6 +12,7 @@
         700: 'FloatField',
         701: 'FloatField',
         869: 'IPAddressField',
+        869: 'IPv46AddressField',
         1043: 'CharField',
         1082: 'DateField',
         1083: 'TimeField',
Index: django/db/backends/postgresql_psycopg2/creation.py
===================================================================
--- django/db/backends/postgresql_psycopg2/creation.py	(revision 16341)
+++ django/db/backends/postgresql_psycopg2/creation.py	(working copy)
@@ -21,6 +21,7 @@
         'IntegerField':      'integer',
         'BigIntegerField':   'bigint',
         'IPAddressField':    'inet',
+        'IPv6AddressField':  'inet',
         'NullBooleanField':  'boolean',
         'OneToOneField':     'integer',
         'PositiveIntegerField': 'integer CHECK ("%(column)s" >= 0)',
Index: django/forms/fields.py
===================================================================
--- django/forms/fields.py	(revision 16341)
+++ django/forms/fields.py	(working copy)
@@ -9,6 +9,7 @@
 import time
 import urlparse
 import warnings
+import socket
 from decimal import Decimal, DecimalException
 try:
     from cStringIO import StringIO
@@ -37,8 +38,8 @@
     'RegexField', 'EmailField', 'FileField', 'ImageField', 'URLField',
     'BooleanField', 'NullBooleanField', 'ChoiceField', 'MultipleChoiceField',
     'ComboField', 'MultiValueField', 'FloatField', 'DecimalField',
-    'SplitDateTimeField', 'IPAddressField', 'FilePathField', 'SlugField',
-    'TypedChoiceField', 'TypedMultipleChoiceField'
+    'SplitDateTimeField', 'IPAddressField', 'IPv46AddressField', 'FilePathField',
+    'SlugField', 'TypedChoiceField', 'TypedMultipleChoiceField'
 )
 
 
@@ -947,6 +948,45 @@
     default_validators = [validators.validate_ipv4_address]
 
 
+class IPv46AddressField(CharField):
+    def __init__(self, only_ipv4=False, only_ipv6=False, skip_ipv6_normalisation=False, *args, **kwargs):
+        self.skip_ipv6_normalisation = skip_ipv6_normalisation
+
+        if only_ipv4 and only_ipv6:
+            raise ValueError(
+                "You can not simultaniously use both only_ipv4 and only_ipv6 on an IPv46AddressField - "
+                "it would generate a field that could never validate")
+
+        self.default_validators = [validators.validate_ipv46_address]
+        self.default_error_messages['invalid'] = _(u'Enter a valid IP address.')
+
+        if only_ipv4:
+            self.default_validators = [validators.validate_ipv4_address]
+            self.default_error_messages['invalid'] = _(u'Enter a valid IPv4 address.')
+
+        if only_ipv6:
+            self.default_validators = [validators.validate_ipv6_address]
+            self.default_error_messages['invalid'] = _(u'Enter a valid IPv6 address.')
+            
+        super(IPv46AddressField, self).__init__(*args, **kwargs)
+        
+    def to_python(self, value):
+        "Try to normalize the address using getaddrinfo"
+        if not value:
+            return ''
+        
+        if self.skip_ipv6_normalisation:
+            return value
+            
+        try:
+            new_value = socket.getaddrinfo(value, None, 0, 0, 0, socket.AI_NUMERICHOST)[0][4][0]
+            return new_value
+        except socket.gaierror:
+            return value
+        
+    default_error_messages = {}
+    
+
 class SlugField(CharField):
     default_error_messages = {
         'invalid': _(u"Enter a valid 'slug' consisting of letters, numbers,"
Index: django/core/validators.py
===================================================================
--- django/core/validators.py	(revision 16341)
+++ django/core/validators.py	(working copy)
@@ -143,6 +143,18 @@
 ipv4_re = re.compile(r'^(25[0-5]|2[0-4]\d|[0-1]?\d?\d)(\.(25[0-5]|2[0-4]\d|[0-1]?\d?\d)){3}$')
 validate_ipv4_address = RegexValidator(ipv4_re, _(u'Enter a valid IPv4 address.'), 'invalid')
 
+ipv6_re = re.compile(r'^((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?$')
+validate_ipv6_address = RegexValidator(ipv6_re, _(u'Enter a valid IPv6 address.'), 'invalid')
+
+def validate_ipv46_address(value): 
+    try: 
+        validate_ipv4_address(value) 
+    except ValidationError: 
+        try: 
+            validate_ipv6_address(value) 
+        except ValidationError: 
+            raise ValidationError(_(u'Enter a valid IP address.'), code='invalid')
+            
 comma_separated_int_list_re = re.compile('^[\d,]+$')
 validate_comma_separated_integer_list = RegexValidator(comma_separated_int_list_re, _(u'Enter only digits separated by commas.'), 'invalid')
 
Index: tests/regressiontests/forms/tests/error_messages.py
===================================================================
--- tests/regressiontests/forms/tests/error_messages.py	(revision 16341)
+++ tests/regressiontests/forms/tests/error_messages.py	(working copy)
@@ -196,6 +196,15 @@
         self.assertFormErrors([u'REQUIRED'], f.clean, '')
         self.assertFormErrors([u'INVALID IP ADDRESS'], f.clean, '127.0.0')
 
+    def test_ipv46addressfield(self):
+        e = {
+            'required': 'REQUIRED',
+            'invalid': 'INVALID IP ADDRESS',
+        }
+        f = IPv46AddressField(error_messages=e)
+        self.assertFormErrors([u'REQUIRED'], f.clean, '')
+        self.assertFormErrors([u'INVALID IP ADDRESS'], f.clean, '127.0.0')
+
     def test_subclassing_errorlist(self):
         class TestForm(Form):
             first_name = CharField()
Index: tests/regressiontests/forms/tests/extra.py
===================================================================
--- tests/regressiontests/forms/tests/extra.py	(revision 16341)
+++ tests/regressiontests/forms/tests/extra.py	(working copy)
@@ -460,6 +460,93 @@
         self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '1.2.3.4.5')
         self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '256.125.1.5')
 
+
+    def test_ipv46address(self):
+        f = IPv46AddressField()
+        self.assertFormErrors([u'This field is required.'], f.clean, '')
+        self.assertFormErrors([u'This field is required.'], f.clean, None)
+        self.assertEqual(f.clean('127.0.0.1'), u'127.0.0.1')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '127.0.0.')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1.2.3.4.5')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '256.125.1.5')
+        self.assertEqual(f.clean('fe80::223:6cff:fe8a:2e8a'), u'fe80::223:6cff:fe8a:2e8a')
+        self.assertEqual(f.clean('2a02::223:6cff:fe8a:2e8a'), u'2a02::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '12345:2:3:4')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1::2:3::4')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, 'foo::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1::2:3:4:5:6:7:8')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1:2')
+        
+        f = IPv46AddressField(only_ipv4=True)
+        self.assertFormErrors([u'This field is required.'], f.clean, '')
+        self.assertFormErrors([u'This field is required.'], f.clean, None)
+        self.assertEqual(f.clean('127.0.0.1'), u'127.0.0.1')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '127.0.0.')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '1.2.3.4.5')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '256.125.1.5')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, 'fe80::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '2a02::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '12345:2:3:4')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '1::2:3::4')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, 'foo::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '1::2:3:4:5:6:7:8')
+        self.assertFormErrors([u'Enter a valid IPv4 address.'], f.clean, '1:2')
+                
+        f = IPv46AddressField(only_ipv6=True)
+        self.assertFormErrors([u'This field is required.'], f.clean, '')
+        self.assertFormErrors([u'This field is required.'], f.clean, None)
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '127.0.0.1')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '127.0.0.')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '1.2.3.4.5')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '256.125.1.5')
+        self.assertEqual(f.clean('fe80::223:6cff:fe8a:2e8a'), u'fe80::223:6cff:fe8a:2e8a')
+        self.assertEqual(f.clean('2a02::223:6cff:fe8a:2e8a'), u'2a02::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '12345:2:3:4')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '1::2:3::4')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, 'foo::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '1::2:3:4:5:6:7:8')
+        self.assertFormErrors([u'Enter a valid IPv6 address.'], f.clean, '1:2')
+
+        f = IPv46AddressField(required=False)
+        self.assertEqual(f.clean(''), u'')
+        self.assertEqual(f.clean(None), u'')
+        self.assertEqual(f.clean('127.0.0.1'), u'127.0.0.1')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '127.0.0.')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1.2.3.4.5')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '256.125.1.5')
+        self.assertEqual(f.clean('fe80::223:6cff:fe8a:2e8a'), u'fe80::223:6cff:fe8a:2e8a')
+        self.assertEqual(f.clean('2a02::223:6cff:fe8a:2e8a'), u'2a02::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, 'foo')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '12345:2:3:4')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1::2:3::4')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, 'foo::223:6cff:fe8a:2e8a')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1::2:3:4:5:6:7:8')
+        self.assertFormErrors([u'Enter a valid IP address.'], f.clean, '1:2')
+
+        self.assertRaises(ValueError, IPv46AddressField, only_ipv4=True, only_ipv6=True)
+
+        # Test the normalising code
+        f = IPv46AddressField(only_ipv6=True)
+        self.assertEqual(f.clean('::ffff:0a0a:0a0a'), u'::ffff:10.10.10.10')
+        self.assertEqual(f.clean('::0a0a:0a0a'), u'::10.10.10.10')
+        self.assertEqual(f.clean('2001:000:a:0000:0:fe:fe:beef'), u'2001:0:a::fe:fe:beef')
+        self.assertEqual(f.clean('2001::a:0000:0:fe:fe:beef'), u'2001:0:a::fe:fe:beef')
+
+        # Test the normalising code
+        f = IPv46AddressField(only_ipv6=True, skip_ipv6_normalisation=True)
+        self.assertEqual(f.clean('::ffff:0a0a:0a0a'), u'::ffff:0a0a:0a0a')
+        self.assertEqual(f.clean('::0a0a:0a0a'), u'::0a0a:0a0a')
+        self.assertEqual(f.clean('2001:000:a:0000:0:fe:fe:beef'), u'2001:000:a:0000:0:fe:fe:beef')
+        self.assertEqual(f.clean('2001::a:0000:0:fe:fe:beef'), u'2001::a:0000:0:fe:fe:beef')
+        
+
     def test_smart_unicode(self):
         class Test:
             def __str__(self):
Index: tests/regressiontests/serializers_regress/tests.py
===================================================================
--- tests/regressiontests/serializers_regress/tests.py	(revision 16341)
+++ tests/regressiontests/serializers_regress/tests.py	(working copy)
@@ -196,6 +196,8 @@
     #(XX, ImageData
     (data_obj, 90, IPAddressData, "127.0.0.1"),
     (data_obj, 91, IPAddressData, None),
+    (data_obj, 95, IPv46AddressData, "fe80:1424:2223:6cff:fe8a:2e8a:2151:abcd"),
+    (data_obj, 96, IPv46AddressData, None),
     (data_obj, 100, NullBooleanData, True),
     (data_obj, 101, NullBooleanData, False),
     (data_obj, 102, NullBooleanData, None),
@@ -298,6 +300,7 @@
     (pk_obj, 682, IntegerPKData, 0),
 #     (XX, ImagePKData
     (pk_obj, 690, IPAddressPKData, "127.0.0.1"),
+    (pk_obj, 695, IPv46AddressPKData, "fe80:1424:2223:6cff:fe8a:2e8a:2151:abcd"),
     # (pk_obj, 700, NullBooleanPKData, True),
     # (pk_obj, 701, NullBooleanPKData, False),
     (pk_obj, 710, PhonePKData, "212-634-5789"),
Index: tests/regressiontests/serializers_regress/models.py
===================================================================
--- tests/regressiontests/serializers_regress/models.py	(revision 16341)
+++ tests/regressiontests/serializers_regress/models.py	(working copy)
@@ -52,6 +52,9 @@
 class IPAddressData(models.Model):
     data = models.IPAddressField(null=True)
 
+class IPv46AddressData(models.Model):
+    data = models.IPv46AddressField(null=True)
+
 class NullBooleanData(models.Model):
     data = models.NullBooleanField(null=True)
 
@@ -187,6 +190,9 @@
 class IPAddressPKData(models.Model):
     data = models.IPAddressField(primary_key=True)
 
+class IPv46AddressPKData(models.Model):
+    data = models.IPv46AddressField(primary_key=True)
+
 # This is just a Boolean field with null=True, and we can't test a PK value of NULL.
 # class NullBooleanPKData(models.Model):
 #     data = models.NullBooleanField(primary_key=True)